con
  _clkmode        = xtal1 + pll16x                '
  _xinfreq        = 5_000_000                     '

obj
  uarts         : "pcFullDuplexSerial4FC"               '1 COG for 4 serial ports

  timer         : "Timer"                               '0 Cog, ctra and ctrb on the calling COG

  config        : "config"                              'no COG

var
  long  stack[50]                                       'requires stack of at least 32
  long  cog
          
pub main
  config.Init(@configinfo,0)                            'config table for this test
  waitcnt(clkfreq*3 + cnt)

  uarts.Init
  uarts.AddPort(0,config.GetPin(CONFIG#DEBUG_RX),config.GetPin(CONFIG#DEBUG_TX), {
}   UARTS#PINNOTUSED,UARTS#PINNOTUSED,UARTS#DEFAULTTHRESHOLD, {
}   UARTS#NOMODE,UARTS#BAUD115200)                      'Add debug port
  uarts.Start                                           'Start the ports
  
  uarts.str(0,string("Starting",13))

  cog := cognew(BackGround,@stack) + 1                  'Start the background Cog

  repeat
    
pub BackGround | day,hour,minute,sec
  timer.Init(config.GetPin(CONFIG#TIME_CLK))                        'allocates ctra and ctrb
  repeat
    timer.UpdateTime
    waitcnt(clkfreq + cnt)
    timer.GetTime(@day,@hour,@minute,@sec)
    uarts.dec(0,day)
    uarts.tx(0," ")  
    uarts.dec(0,hour)
    uarts.tx(0,":")  
    uarts.dec(0,minute)
    uarts.tx(0,":")  
    uarts.dec(0,sec)
    uarts.tx(0,13)  
    
DAT
'' Configuration table for pins
''
configinfo    word CONFIG#TIME_CLK              'pin 0
              word CONFIG#NOT_USED              'pin 1
              word CONFIG#NOT_USED              'pin 2
              word CONFIG#NOT_USED              'pin 3
              word CONFIG#NOT_USED              'pin 4
              word CONFIG#NOT_USED              'pin 5
              word CONFIG#NOT_USED              'pin 6
              word CONFIG#NOT_USED              'pin 7
              word CONFIG#NOT_USED              'pin 8
              word CONFIG#NOT_USED              'pin 9
              word CONFIG#NOT_USED              'pin 10
              word CONFIG#NOT_USED              'pin 11
              word CONFIG#NOT_USED              'pin 12
              word CONFIG#NOT_USED              'pin 13
              word CONFIG#NOT_USED              'pin 14
              word CONFIG#NOT_USED              'pin 15
              word CONFIG#NOT_USED              'pin 16
              word CONFIG#NOT_USED              'pin 17
              word CONFIG#NOT_USED              'pin 18
              word CONFIG#NOT_USED              'pin 19
              word CONFIG#NOT_USED              'pin 20
              word CONFIG#NOT_USED              'pin 21
              word CONFIG#NOT_USED              'pin 22
              word CONFIG#NOT_USED              'pin 23
              word CONFIG#NOT_USED              'pin 24
              word CONFIG#NOT_USED              'pin 25
              word CONFIG#NOT_USED              'pin 26
              word CONFIG#NOT_USED              'pin 27
              word CONFIG#I2C_SCL1              'pin 28
              word CONFIG#I2C_SDA1              'pin 29
              word CONFIG#DEBUG_TX              'pin 30
              word CONFIG#DEBUG_RX              'pin 31           